#-- 
#  Copyright (C) 2008 Red Hat Inc.
#  
#  This library is free software; you can redistribute it and/or
#  modify it under the terms of the GNU Lesser General Public
#  License as published by the Free Software Foundation; either
#  version 2.1 of the License, or (at your option) any later version.
#  
#  This library is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Lesser General Public License for more details.
#  
#  You should have received a copy of the GNU Lesser General Public
#  License along with this library; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
#
# Author: Bryan Kearney <bkearney@redhat.com>
#--

import "appliance_base"

class postgres {	
	
	single_exec{"initialize_postgres" :
		command => "/sbin/service postgresql initdb"
	}
	
	service {"postgresql":
		ensure => running,
		enable => true,
		hasstatus => "true",		
		require => Single_exec["initialize_postgres"]
	}
}


define postgres::setup() {
	include postgres
}

define postgres::enable_login($database="all", $method="md5", $type="local", $address="") {
	
	file_replacement{"horde_enable_login_$name":
		file => "/var/lib/pgsql/data/pg_hba.conf",
		pattern => "^local *all *all *ident sameuser",
		replacement => "$type    $database    $name    $address    $method\nlocal    all    all    ident sameuser",
		notify => Service["postgresql"]
	}
}
