#-- 
#  Copyright (C) 2008 Red Hat Inc.
#  
#  This library is free software; you can redistribute it and/or
#  modify it under the terms of the GNU Lesser General Public
#  License as published by the Free Software Foundation; either
#  version 2.1 of the License, or (at your option) any later version.
#  
#  This library is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Lesser General Public License for more details.
#  
#  You should have received a copy of the GNU Lesser General Public
#  License along with this library; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
#
# Author: Bryan Kearney <bkearney@redhat.com>
#--

# Executes a postgres sql file, and drops a file 
# to record that it was executed.
Puppet::Type.newtype(:postgres_execute_file) do
        include Puppet::Util
       
        newparam (:name) do 
        	isnamevar
        end    

        newparam (:user) do 
        	
        end
        
        newparam (:password) do 
        	
        end        
        
        newparam (:database) do 
        	
        end 
        
        newparam(:sql_file) do
        end       
        
        newproperty(:returns) do |property|
            include Puppet::Util
            
            munge do |value|
                value.to_s
            end
            
            defaultto 0

            # Make output a bit prettier
            def change_to_s(currentvalue, newvalue)
                return "executed successfully"
            end
            
            def retrieve
                # Returns garbage if we need to run,or the current
                # value if we do not.
                if !FileTest.exists?("/var/ace/single_execs/#{self.resource[:name]}")        
                    return :need_to_run_this
                else         
                    return self.should
                end
            end            

            # Actually execute the command.
            def sync          
                cmd = ["/usr/bin/psql"]
				cmd << " -d #{self.resource[:database]}" if self.resource[:database]		
				cmd << " --username #{self.resource[:user]}" if self.resource[:user]
				cmd << " --password #{self.resource[:password]}" if self.resource[:password]
				cmd << " -f #{self.resource[:sql_file]}" if self.resource[:sql_file]				

                begin
                    output = execute(cmd,{:failonfail => true, :uid=>"postgres", :gid=>"postgres"})
                rescue Timeout::Error
                    self.fail "Command exceeded timeout" % value.inspect
                end

				execute(["/bin/date >> /var/ace/single_execs/#{self.resource[:name]}"])
				
                return :executed
            end
		end
end
